# Makefile.inc example. Works with the GNU compilers & OpenMPI.

# Flags to be passed to compilers (C++, C, Fortran, mex)
# CXXFLAGS is mandatory. Flags for the C++ compiler.
# CFLAGS is optional (used only for the C and Fortran interface).
# FFLAGS is optional (used only for the Fortran interface, or with -DHQR). 
# MEXFLAGS is optional (used only for the Octave/Matlab interface).
CXXFLAGS  = -O3 #-DHQR #-DRANDGEN -DRANGENNORMAL -std=c++11
CFLAGS    = -O3
FFLAGS    = -O3
MEXFLAGS  = --mex

# Compilers  (C++, C, Fortran, mex)
# CXX is mandatory. C++ compiler.
# CC is optional (used only for the C and Fortran interface).
# FC is optional (used only for the Fortran interface, or with -DHQR). 
# MEXis optional (used only for the Octave/Matlab interface).
CXX       = mpic++
CC        = mpicc
FC        = mpif90
MEX       = mkoctfile


# Libraries:
# LIB should provide ScaLAPACK, BLACS, LAPACK, BLAS
# LIBCXX is used for the Fortran interface, to provide C++ libraries to the linker
# LIBMEX is used for the mex interface
LIB       = -Wl,-rpath,/opt/petsc-3.6.2/linux-intel-opt32/lib -L/opt/petsc-3.6.2/linux-intel-opt32/lib  -lpetsc -Wl,-rpath,/opt/petsc-3.6.2/linux-intel-opt32/lib -lcmumps -ldmumps -lsmumps -lzmumps -lmumps_common -lpord -lscalapack -lumfpack -lklu -lcholmod -lbtf -lccolamd -lcolamd -lcamd -lamd -lsuitesparseconfig -lHYPRE -Wl,-rpath,/usr/lib/openmpi/lib -L/usr/lib/openmpi/lib -Wl,-rpath,/usr/lib/gcc/x86_64-linux-gnu/4.8 -L/usr/lib/gcc/x86_64-linux-gnu/4.8 -Wl,-rpath,/usr/lib/x86_64-linux-gnu -L/usr/lib/x86_64-linux-gnu -Wl,-rpath,/lib/x86_64-linux-gnu -L/lib/x86_64-linux-gnu -lmpi_cxx -lstdc++ -lflapack -lfblas -lparmetis -lmetis -lm -lmpi_f90 -lmpi_f77 -lgfortran -lm -lgfortran -lm -lquadmath -lm -lmpi_cxx -lstdc++ -Wl,-rpath,/usr/lib/openmpi/lib -L/usr/lib/openmpi/lib -Wl,-rpath,/usr/lib/gcc/x86_64-linux-gnu/4.8 -L/usr/lib/gcc/x86_64-linux-gnu/4.8 -Wl,-rpath,/usr/lib/x86_64-linux-gnu -L/usr/lib/x86_64-linux-gnu -Wl,-rpath,/lib/x86_64-linux-gnu -L/lib/x86_64-linux-gnu -Wl,-rpath,/usr/lib/x86_64-linux-gnu -L/usr/lib/x86_64-linux-gnu -ldl -lmpi -lhwloc -lgcc_s -lpthread -ldl 
#LIB      = -L/home/naage/install/scalapack_1.0.2/lib/ -lscalapack -lrefblas -ltmg -lreflapack -lm -lgfortran
LIBCXX    = -lstdc++ -lmpi_cxx
LIBMEX    = -L/usr/lib/openmpi -lmpi_cxx -lscalapack -lblas


