#include <petsc.h>
#include "StrumpackDensePackage.h"

#define ARITH_D 0
#define ARITH ARITH_D
#if ARITH==ARITH_D
#define myscalar double
#define myreal double
#endif


#define strucaux(x) StrumpackDensePackage_C_ ## x
#define struc(x) strucaux(x)
#define funcaux(x,y) SDP_C_ ## y ## _ ## x
#define funceval(x,y) funcaux(x,y)
#define func(x) funceval(x,myscalar)


static char help[] = "TEST STRUMPACK PETSC \n";

int main(int argc, char *argv[]){

	// Error code for debugging
	PetscErrorCode ierr;
	
	// Initialize PETSc / MPI and pass input arguments to PETSc
	PetscInitialize(&argc,&argv,PETSC_NULL,help);

	// Use strumpack struct
	struc(myscalar) SDP_C;
	
	// Call a strumpack function
	func(init)(&SDP_C,PETSC_COMM_WORLD);

	// Finalize PETSc / MPI
	PetscFinalize();
	return 0;
}
